#include <stdio.h>
#include <conio.h>
#include <dos.h>

#include "kbd.h"
#include "irqprobe.h"
#include "dev.h"


int kbd_probe_irq;
int rcv_echo;

void far kbd_probeirq (int irq)
{
  if (inp(0x64)&1)
  {
   kbd_probe_irq = irq;
   rcv_echo = inp(0x60);
  }
}

void kb_wait(void)
{
 int timeout;

 do {
  timeout++;
  delay(1);
 }while ( (!(inp(0x64)&2)) && (timeout<100) );
}



int kbd_probe()
{
 int timeout;
 isadev *dev;

 if (!ask_for_probe("PC Keyboard",0x60))
   return 0;

 kbd_probe_irq = -1;
 kb_wait();
 init_irqprobe (kbd_probeirq);
 outp(0x60, 0xee);
 timeout = 0;
 do{
  delay(1);
  timeout++;
 }while ( (rcv_echo!=0xee) &&(timeout<100) );
 done_irqprobe ();

  dev = alloc_isadev();
  setisadevname(dev,"PC Keyboard");
  setisadevport(dev,0x60);
  allocisadevirq(dev,kbd_probe_irq);
  add_isadevproperty(dev,"Test",rcv_echo==0xee?"passed":"failed");
  if (kbd_probe_irq!=1)
   add_isadevproperty(dev,"IRQ","Incompatible IRQ");
  addisadev(dev);
 return 1;
}