#include <stdio.h>
#include <conio.h>

#include "dev.h"
#include "net/smc.h"
#include "net/ne.h"
#include "net/wd.h"
#include "net/3c509.h"
#include "net/icl16.h"
#include "net/hp-plus.h"

#include "hgc.h"
#include "serial.h"
#include "dma.h"
#include "lpt.h"
#include "kbd.h"
#include "lib/cons.h"
#include "cdu31a.h"

void
main ()
{
  int i;

  clrscr();

  writech(0,0,' ',80,0x70);
  writes(0,0,"ISAprobe",0x70);
  printf ("\n\nisaprobe: version 0.2 (c) 1998-99 Martin Hinner <mhi@penguin.cz>\n"
	  "          http://www.penguin.cz/~mhi/isaprobe/\n"
	  "          ftp.penguin.cz /pub/users/mhi/isaprobe/\n\n");

  init_dev();

  dma_probe();

  for (i = 0; i < 16; i++)
    smc_probe (0x200 + (i * 0x20));
  for (i = 0; i < 16; i++)
    ne_probe (0x200 + (i * 0x20));
  for (i = 0; i < 16; i++)
    wd_probe (0x200 + (i * 0x20));
  for (i=0x200;i<=0x300;i+=0x10)
    icl16_probe(i);
  for (i=0x200;i<0x360;i+=0x20)
    hpplus_probe(i);


  serial_probe(0x3f8);
  serial_probe(0x2f8);
  serial_probe(0x3e8);
  serial_probe(0x2e8);

  lpt_probe(0x3bc);
  lpt_probe(0x378);
  lpt_probe(0x278);

  hgc_probe();
  kbd_probe();

  cdu31a_probe(0x230);      /* SoundBlaster 16 card */
  cdu31a_probe(0x320);      /* Secondary standard Sony Interface */
  cdu31a_probe(0x330);      /* Secondary standard Sony Interface */
  cdu31a_probe(0x340);      /* Standard configuration Sony Interface */
  cdu31a_probe(0x360);      /* Secondary standard Sony Interface */
  cdu31a_probe(0x634);      /* Sound FX SC400 */
  cdu31a_probe(0x654);      /* Sound FX SC400 */
  cdu31a_probe(0x1f88);     /* Fusion CD-16, PAS-16 */

  while (el3_probe()) ;

  dump_devices();
}