#ifndef __HP_PLUS_H
#define __HP_PLUS_H

#define HP_ID			0x00	/* ID register, always 0x4850. */
#define HP_PAGING		0x02	/* Registers visible @ 8-f, see PageName. */
#define HPP_OPTION		0x04	/* Bitmapped options, see HP_Option.	*/
#define HPP_OUT_ADDR	0x08	/* I/O output location in Perf_Page.	*/
#define HPP_IN_ADDR		0x0A	/* I/O input location in Perf_Page.		*/
#define HP_DATAPORT		0x0c	/* I/O data transfer in Perf_Page.		*/

#define	HP_PERF_PAGE  0				/* Normal operation. */
#define HP_MAC_PAGE   1				/* The ethernet address (+checksum). */
#define HP_HW_PAGE    2				/* EEPROM-loaded hardware parameters. */
#define HP_LAN_PAGE   4				/* Transceiver selection, testing, etc. */
#define HP_ID_PAGE    6

#define HP_MEM_ENABLE 0x40

#ifdef __cplusplus
extern "C" {
#endif

extern int hpplus_probe (int port);

#ifdef __cplusplus
 };
#endif


#endif